{
  Startovn slo: 28

  Pouit moduly:
    _28SafetyMatches.dpr
    _28NewGameForm.pas + .dfm
    _28PlayerNameForm.pas + .dfm
    _28Form1.pas + .dfm

}

unit _28Form1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Grids, ComCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    GamePanel: TPanel;
    GameImage: TImage;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    ScoreLabel1: TLabel;
    ScoreLabel2: TLabel;
    ActiveShape: TShape;
    DummyEdit: TEdit;
    Label3: TLabel;
    Top10Grid: TStringGrid;
    Button2: TButton;
    Timer: TTimer;
    DelayGroup: TGroupBox;
    TrackBar: TTrackBar;
    Label4: TLabel;
    Label0: TLabel;
    Label1000: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Label5: TLabel;
    procedure NewGame(Sender: TObject);
    procedure GameImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure GameImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure Help(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure TrackBarChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure UpdateTop10;
    procedure LoadTop10;
    procedure SaveTop10;
    procedure Redraw;
    procedure PlaceMatch;
    procedure Continue;
  end;

var
  Form1: TForm1;

implementation

uses _28NewGameForm, _28PlayerNameForm;

const
  MaxN = 10;     // maxim. rozmry her. pole
  FieldSize=32;  // velikost 1 polka v pixelech

type
  TPlayer=(pA,pB);                  // vtov typ pro dva hre - A a B
  TMatch=(mNone,mPlayerA,mPlayerB); // vtov typ pro barvu hrany/polka - dn nebo jednoho z hr

const
  MatchColor:array [tmatch]of tcolor=(clnone,clred,clblue);     // barvy polek a hran
  FieldColor:array [tmatch]of tcolor=(clnone,$C0FFC0,$C0C0FF);
  NewColor=clgray;
  PlayerNames:array[tplayer] of string = ('Hr 1','Hr 2'); // jmna hr

  gkHumanHuman = 0; // mdy hry
  gkHumanCPU = 1;
  gkCPUCPU = 2;

var
  Horiz:array[-1..MaxN,-1..MaxN+1] of TMatch; // vodorovn hrany
  Vert:array[-1..MaxN+1,-1..MaxN] of TMatch;  // svisl hrany
  Fields:array[0..maxN,0..maxn] of tmatch;    // polka
  N:integer;                             // rozmry her. pole
  ActivePlayer:tplayer;                  // prv hrajc hr
  NewX,NewY:integer; NewHoriz:boolean;   // poloha + orientace nov umisovan sirky
  Points:array[tplayer] of integer;      // skre
  GameKind:integer;                      // md hry

type
  TTop10=record  // 1 poloka tabulky Top 10
    Name:String;
    Score:integer;
  end;

const
  Top10Count = 10; // poet lid v Top 10
  Top10File='_28TopTen.txt'; // soubor kde se tabulka pamatuje

var
  Top10:array [0..top10count-1] of ttop10; // data Top 10

{$R *.DFM}

// vype data z Top10 do seznamu na formuli
procedure TForm1.UpdateTop10;
var
  i:integer;
begin
  for i:=0 to top10count-1 do
    with Top10Grid do
    begin
      cells[0,i]:=top10[i].name;
      cells[1,i]:=inttostr(top10[i].Score);
    end;
end;

// Nate Top10 ze souboru. Pokud tento soubor neexistuje, data se nastav
// na defaultn hodnoty.
procedure TForm1.LoadTop10;
var
  F:textfile;
  I:integer;
begin
  if fileexists(extractfilepath(application.exename)+top10file) then
  begin
    assignfile(f,extractfilepath(application.exename)+top10file);
    reset(f);
    for i:=0 to top10count-1 do
    begin
      readln(f,top10[i].name);
      readln(f,top10[i].score);
    end;
    closefile(f);
  end
  else
  begin
    for i:=0 to top10count-1 do
    begin
      top10[i].name:='(nikdo)';
      top10[i].score:=0;
    end;
  end;
end;

// Ulo Top 10 do souboru
procedure TForm1.SaveTop10;
var
  f:textfile;
  i:integer;
begin
  assignfile(f,extractfilepath(application.exename)+top10file);
  rewrite(f);
  for i:=0 to top10count-1 do
  begin
    writeln(f,top10[i].name);
    writeln(f,top10[i].score);
  end;
  closefile(f);
end;

// Umst sirku na pozici daou v globl. promnch NewX, NewY a NewHoriz a provede
// potebn kalkulace (piten bod, vhra/prohra...).
procedure TForm1.PlaceMatch;
var
  Match:tmatch;
  AllFieldsFull:boolean;
  x,y:integer;
  Winner:tplayer;
  I,PosInTop10:integer;
  PointGiven:boolean;
begin
  case activeplayer of // nastven barvy pro vyplnn hran/tverek
    pa:Match:=mPlayerA;
    pB:match:=mPlayerB;
  else
    match:=mnone;
  end;

  // PointGiven se pozdji nastav na True, kdy se hrovi pite bod
  pointgiven:=false;
  if newhoriz then // pokud je orientace sirky vodorovn...
    if horiz[newx,newy]=mnone then // ... a na danm polku je volno
    begin
      horiz[newx,newy]:=match; // nasav se data hrany
      // Nsleduje detekce, zda se neuzavel tverec. pokud ano, vybravme ho a piteme body
      if (horiz[newx,newy-1]<>mnone)and(vert[newx,newy-1]<>mnone)and(vert[newx+1,newy-1]<>mnone)then
      begin
        fields[newx,newy-1]:=match;
        inc(points[activeplayer]);
        pointgiven:=true;
      end;
      if (horiz[newx,newy+1]<>mnone)and(vert[newx,newy]<>mnone)and(vert[newx+1,newy]<>mnone)then
      begin
        fields[newx,newy]:=match;
        inc(points[activeplayer]);
        pointgiven:=true;
      end;
    end
    else
    begin
      application.messagebox('Sem nelze zpalku umstit, protoe tam u jedna je.','Chyba',mb_iconexclamation);
      exit;
    end
  else // analogicky pro svisle orientovanou sirku
    if vert[newx,newy]=mnone then
    begin
      vert[newx,newy]:=match;
      if (vert[newx-1,newy]<>mnone)and(horiz[newx-1,newy]<>mnone)and(horiz[newx-1,newy+1]<>mnone)then
      begin
        fields[newx-1,newy]:=match;
        inc(points[activeplayer]);
        pointgiven:=true;
      end;
      if (vert[newx+1,newy]<>mnone)and(horiz[newx,newy]<>mnone)and(horiz[newx,newy+1]<>mnone)then
      begin
        fields[newx,newy]:=match;
        inc(points[activeplayer]);
        pointgiven:=true;
      end;
    end
    else
    begin
      application.messagebox('Sem nelze zpalku umstit, protoe tam u jedna je.','Chyba',mb_iconexclamation);
      exit;
    end;

  // pokud jsme nepidlili hrovi bod, hraje ten druh
  if not pointgiven then
    case activeplayer of
      pA:activeplayer:=pB;
      pB:activeplayer:=pA;
    end;
  redraw;

  // projedeme vechny hrany, jestli u nejsou zaplnn
  AllFieldsFull:=true;
  for y:=0 to n do
    for x:=0 to n-1 do
      if horiz[x,y]=mnone then
      begin
        allfieldsfull:=false;
        break;
      end;
  for y:=0 to n-1 do
    for x:=0 to n do
      if vert[x,y]=mnone then
      begin
        allfieldsfull:=false;
        break;
      end;

  // poud jsou hrany zaplnn, dme monost ukonit hru/zat novou
  if allfieldsfull then
  begin
    timer.enabled:=false;
    if points[pA]=points[pB] then
    begin
      if application.messagebox(pchar('Hra skonila, oba hri maj stejn bod. Chcete hrt znovu?'),
        'Konec hry',mb_yesno)=id_yes then
        newgame(self)
      else
        application.terminate;
    end
    else
    begin
      if points[pA]>points[pB] then
        winner:=pA
      else
        winner:=pB;
      if application.messagebox(pchar(format('Hra skonila, vyhrl %s. Chcete hrt znovu?',[playernames[winner]])),
        'Konec hry',mb_yesno)=id_yes then
        newgame(self)
      else
        application.terminate;

      // zjistme pozici vtze v Top 10
      posintop10:=10;
      for i:=top10count-1 downto 0 do
        if points[winner]>=top10[i].score then
          PosInTop10:=i;
      // pokud je hr lovk (ne CPU!!!) a m odpovdajc skre, pidme ho do Top 10
      if ((gamekind=gkhumanhuman)or((gamekind=gkhumancpu)and(winner=pA))) and(posintop10 < 10)and(points[winner]>0) then
        with playernameform do
          if showmodal =mrok then
          begin
            for i:=posintop10 to top10count-2 do
              top10[i+1]:=top10[i];
            top10[PosInTop10].name:=nameedit.text;
            top10[PosInTop10].score:=points[winner];
            updatetop10;
          end;
    end;
  end;
end;

// pokud se hraje hra lovk x pota, a na tahu je pota, nechme ho hrt
procedure TForm1.Continue;
begin
  if gamekind = gkHumanCPU then
    repeat
      help(self);
    until activeplayer =pA
end;

// pekreslen hrac plochy a skre
procedure TForm1.Redraw;
var
  i,x,y:integer;
begin
  with gameimage do
  begin
    // nastaven velikosti objekt 
    width:=n*fieldsize;
    height:=n*fieldsize;
    gamepanel.width:=width+4;
    gamepanel.height:=height+4;
    with canvas do
    begin
      // pozad a ry
      brush.color:=clwhite;
      fillrect(rect(0,0,width,height));
      pen.color:=clsilver;
      for i:=1 to n-1 do
      begin
        moveto(i*fieldsize,0);
        lineto(i*fieldsize,n*fieldsize);
        moveto(0,i*fieldsize);
        lineto(n*fieldsize,i*fieldsize);
      end;

      // vykreslen vybarvench tverek
      for x:=0 to n-1 do
        for y:=0 to n-1 do
          if fields[x,y]<>mnone then
          begin
            if fields[x,y]=mplayerA then
              brush.color:=rgb(255,192,192)
            else
              brush.color:=rgb(192,192,255);
            fillrect(rect(x*fieldsize,y*fieldsize,(x+1)*fieldsize,(y+1)*fieldsize));
          end;

      // vykreslen sirek
      pen.Width:=3;
      for y:=0 to n do
        for x:=0 to n-1 do
        begin
          if horiz[x,y]<>mnone then
          begin
            pen.color:=matchcolor[horiz[x,y]];
            moveto(x*fieldsize,y*fieldsize);
            lineto((x+1)*fieldsize,y*fieldsize);
          end;
        end;
      for y:=0 to n-1 do
        for x:=0 to n do
        begin
          if vert[x,y]<>mnone then
          begin
            pen.color:=matchcolor[vert[x,y]];
            moveto(x*fieldsize,y*fieldsize);
            lineto(x*fieldsize,(y+1)*fieldsize);
          end;
        end;

      // vykreslen prv pidvan sirky
      pen.color:=newcolor;
      if newhoriz then
      begin
        moveto(newx*fieldsize,newy*fieldsize);
        lineto((newx+1)*fieldsize,newy*fieldsize);
      end
      else
      begin
        moveto(newx*fieldsize,newy*fieldsize);
        lineto(newx*fieldsize,(newy+1)*fieldsize);
      end;
      pen.width:=1;
    end;
  end;

  // posum znaky aktivnho hre
  case activeplayer of
    pa: activeshape.top:=16;
    pb: activeshape.top:=40;
  end;

  // update score
  ScoreLabel1.caption:=inttostr(points[pA]);
  ScoreLabel2.caption:=inttostr(points[pB]);

  // pesun fokusu na DummyEdit => tam odchytvme klvesnicov eventy, kter
  // TImage neum zpracovvat (a little trick :-)
  activecontrol:=dummyedit;
end;

// zahj novou hru
procedure TForm1.NewGame(Sender: TObject);
var
  x,y:integer;
begin
  with newgameform do
    // zobrazen formule na vbr rozmr a mdu hry
    if showmodal=mrok then
    begin
      n:=nupdown.position;
      gamekind:=GameKindGroup.itemindex;
      // vynulovn datovch struktur
      for y:=0 to n do
        for x:=0 to n-1 do
          horiz[x,y]:=mnone;
      for y:=0 to n-1 do
        for x:=0 to n do
          vert[x,y]:=mnone;
      for y:=0 to n-1 do
        for x:= 0 to n-1 do
          fields[x,y]:=mnone;
      points[pA]:=0;
      points[pB]:=0;
      activeplayer:=pA;
      // update control na formuli
      if gamekind = gkCPUCPU then
      begin
        timer.enabled:=true;
        delaygroup.enabled:=true;
        label0.enabled:=true;
        label1000.enabled:=true;
      end
      else
      begin
        timer.enabled:=false;
        delaygroup.enabled:=false;
        label0.enabled:=false;
        label1000.enabled:=false;
      end;
      redraw;
    end
    else
      application.terminate;
end;

procedure TForm1.GameImageMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  BaseX,BaseY:integer;
  DiffX,DiffY:integer;
begin
  // urme, na kterou hranu ukazuje uivatel my
  BaseX:=(x+fieldsize div 2) div fieldsize;
  BaseY:=(y+fieldsize div 2) div fieldsize;
  DiffX:=(x+fieldsize div 2) mod fieldsize;
  diffy:=(y+fieldsize div 2) mod fieldsize;
  if diffx<diffy then
    newhoriz:=false
  else
    newhoriz:=true;

  newx:=basex;
  newy:=basey;
  redraw;
end;

procedure TForm1.GameImageMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  // po kliknut my umstme sirku a nechme hru pokraovat
  placematch;
  continue;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  // po stisku klves udlme odpovdajc posuny pozice pidvan sirky,
  // resp. ji pidme, je-li stisknut Enter
  case key of
    vk_right:
      if (newhoriz and (newx<n-1))or (not newhoriz and (newx<n)) then inc(newx);
    vk_left:
      if newx>0 then dec(newx);
    vk_down:
      if (newhoriz and (newy<n))or (not newhoriz and (newy<n-1)) then inc(newy);
    vk_up:
      if newy>0 then dec(newy);
    vk_space: newhoriz:=not newhoriz;
    vk_return:
    begin
      placematch;
      continue;
    end;
  end;
  redraw;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  // pi startu nateme Top 10 a zahjme novou hru
  loadtop10;
  updatetop10;
  newgame(self);
  activecontrol:=dummyedit;
end;

procedure TForm1.FormHide(Sender: TObject);
begin
  // na konci ulome Top 10
  savetop10;
end;

// Tato procedura tvo celou "umlou intligeci" potae.
procedure TForm1.Help(Sender: TObject);
var
  TipX,TipY:integer;
  TipHoriz:boolean;

  procedure SaveTip(DX,DY:integer);
  begin
    tipx:=newx+dx;
    tipy:=newy+dy;
    tiphoriz:=newhoriz;
  end;

begin
  // TipX a spol. uruj zatm odhadnutou pozici, kam umstit sirku. Hodnota -1
  // znemena, e jet nevme.
  tipx:=-1;
  tipy:=-1;

  // Nejdv prozkoumme, zda poloenm vodorovn sirky nejde uzavt njak tverec.
  // Pokud ano, zapamatujeme s daje pomoc SaveTip. Pak tot provedem pro
  // svislou sirku.
  newhoriz:=true;
  for newy:=0 to n do
    for newx:=0 to n-1 do
      if horiz[newx,newy]=mnone then
      begin
        if (horiz[newx,newy-1]<>mnone)and(vert[newx,newy-1]<>mnone)and(vert[newx+1,newy-1]<>mnone)then
          savetip(0,0);
        if (horiz[newx,newy+1]<>mnone)and(vert[newx,newy]<>mnone)and(vert[newx+1,newy]<>mnone)then
          savetip(0,0);
      end;

  newhoriz:=false;
  for newy:=0 to n-1 do
    for newx:=0 to n do
      if vert[newx,newy]=mnone then
      begin
        if (vert[newx-1,newy]<>mnone)and(horiz[newx-1,newy]<>mnone)and(horiz[newx-1,newy+1]<>mnone)then
          savetip(0,0);
        if (vert[newx+1,newy]<>mnone)and(horiz[newx,newy]<>mnone)and(horiz[newx,newy+1]<>mnone)then
          savetip(0,0);
      end;

  // Pokud nebylo mon dn tverec uzavt, pokraujeme dl...
  if (tipx=-1)or(tipy=-1)then
  begin
    // Ve 2. kroku nalzme budouc tverce, kter maj hranu je z 1 sirky. V tom ppad
    // polome ndo protj hrany 2. sirku. Pokud bude soupe dostaten zmaten, je mon,
    // e polo sirku 3. a v dalm prchodu meme tverec zavt se ziskem bodu.

    // Uml inteligence se sna nikdy nepoloit 2. sirku do tverce, radji "nane" nov.

    newhoriz:=true;
    for newy:=1 to n-1 do
      for newx:=0 to n-1 do
        if horiz[newx,newy]<>mnone then
        begin
          if (horiz[newx,newy-1]=mnone)and(vert[newx,newy-1]=mnone)and(vert[newx+1,newy-1]=mnone)then
            savetip(0,-1);
          if (horiz[newx,newy+1]=mnone)and(vert[newx,newy]=mnone)and(vert[newx+1,newy]=mnone)then
            savetip(0,+1);
        end;

    newhoriz:=false;
    for newy:=0 to n-1 do
      for newx:=1 to n-1 do
        if vert[newx,newy]<>mnone then
        begin
          if (vert[newx-1,newy]=mnone)and(horiz[newx-1,newy]=mnone)and(horiz[newx-1,newy+1]=mnone)then
            savetip(-1,0);
          if (vert[newx+1,newy]=mnone)and(horiz[newx,newy]=mnone)and(horiz[newx,newy+1]=mnone)then
            savetip(+1,0);
        end;
  end;

  // Pokud ani po pedchozm kroku nnajdeme vhodnou polohu, znamn to, e musme
  // nkam poloit 3. nebo 1. sirku do tverce. Pozici, kam ji nakonec dme
  // volm nhodn.
  if (tipx=-1)or(tipy=-1)then
  begin
    repeat
      if random(2)=0 then
        newhoriz:=true
      else
        newhoriz:=false;
      if newhoriz then
      begin
        newx:=random(n);
        newy:=random(n+1);
      end
      else
      begin
        newx:=random(n+1);
        newy:=random(n);
      end
    until (newhoriz and (horiz[newx,newy]=mnone))or(not newhoriz and (vert[newx,newy]=mnone));
    savetip(0,0);
  end;

  if (tipx<>-1)and(tipy<>-1) then
  begin
    newx:=tipx;
    newy:=tipy;
    newhoriz:=tiphoriz;
    placematch;
  end;
end;

// Periodick opakovn pi he pota x pota
procedure TForm1.TimerTimer(Sender: TObject);
begin
  help(self);
  application.processmessages;
end;

// event otujc zmnu dlky prodlevy mezi tahy pota pi he pota x pota
procedure TForm1.TrackBarChange(Sender: TObject);
begin
  timer.Interval:=trackbar.position;
end;

end.
